*****************************************************
* DATA.......: 26/04/2023                           *
* PROGRAMA...: TST1.PRG                             *
* FUNCAO.....: EXEMPLIFICAR O USO DO SIBRA          *
* PROGRAMADOR: ANDERSON CARDOSO SILVA               *
* WEBSITE....: www.linguagemclipper.com.br/sibra    *
*****************************************************

FUNCTION MAIN()

SETCOLOR("W+/W")
SET SCORE OFF
SET DATE BRITISH
SET EPOCH TO 1980
SETCANCEL(.F.)

#define RGB( nR,nG,nB ) ( nR + ( nG * 256 ) + ( nB * 256 * 256 ) ) 
#define PS_SOLID   0 
#define BLACK           RGB( 0x0 ,0x0 ,0x0 ) 
#define BLUE            RGB( 0x0 ,0x0 ,0x85 ) 
#define GREEN           RGB( 0x0 ,0x85,0x0 ) 
#define CYAN            RGB( 0x0 ,0x85,0x85 ) 
#define RED             RGB( 0x85,0x0 ,0x0 ) 
#define MAGENTA         RGB( 0x85,0x0 ,0x85 ) 
#define BROWN           RGB( 0x85,0x85,0x0 ) 
#define WHITE           RGB( 0xC6,0xC6,0xC6 ) 

*** DEFINIR IDIOMA PORTUGUS ***
// APENAS PARA XHARBOUR E HARBOUR
#IFDEF __XHARBOUR
	REQUEST HB_LANG_PT
	REQUEST HB_CODEPAGE_PT850 &&& PARA INDEXAR CAMPOS ACENTUADOS
	HB_LangSelect("PT")
	HB_SetCodePage("PT850")
	SET( 100, "PT") // _SET_LANGUAGE
#ENDIF
#IFDEF __HARBOUR__
	REQUEST HB_LANG_PT
	REQUEST HB_CODEPAGE_PT850 &&& PARA INDEXAR CAMPOS ACENTUADOS
	HB_LangSelect("PT")
	HB_SetCodePage("PT850")
	SET( 100, "PT") // _SET_LANGUAGE
#ENDIF
SETMODE(25,80)

#INCLUDE "HBZEBRA.CH"

CLS
@ 00,00 SAY PADC("TESTE DE RELATORIO COM:", 80, " ")
@ 01,00 SAY PADC("SIBRA", 80, " ")

?;?

TEXT
               Sistema de Impressao BRAsileiro - SIBRA

     Lib para imprimir relatrio com o Clipper em qualquer impressora
     Utiliza fontes do Windows; cores; grficos; cdigo de barras e
     at cria relatrios dentro de planilha do Excel.

              https://www.linguagemclipper.com.br/sibra
                anderson@linguagemclipper.com.br

                 Programado por Anderson Cardoso Silva
                         55 (82) 99141-9420
                         Macei/AL : BRASIL

ENDTEXT

*--------------------------------------------------------------------------
* ESTE EXEMPLO FOI FEITO PARA MELHOR DEMONSTRAR O SIBRA
*--------------------------------------------------------------------------
* ESTE PROGRAMA EXEMPLO EU TIREI DE UM SISTEMA MEU, ANTIGO, DE
* DE CONTAS A RECEBER DE UM SUPERMERCADO DO INTERIOR DE ALAGOAS.
* ESTOU PRE-SELECIONANDO O RELATORIO 3, POIS ESTE PROGRAMA FAZ 4 RELATORIOS
* DIFERENTES E APLIQUEI O TEXTO RICO.
*--------------------------------------------------------------------------

// TRjanela(li,ci,lf,cf,cor,cTITULO, lSOMBRA, cBOX, lGAS)
TRJANELA(15,15,18,55,,"Modo de impresso", .T.)
nTST=1

lPAISAGEM := .F.
@ 16,20 PROMPT " 1. TESTE RETRATO             "
@ 17,20 PROMPT " 2. TESTE PAISAGEM            "
MENU TO nTST

IF LASTKEY() = 27
   QUIT
ENDIF

IF nTST=1
   lPAISAGEM := .F.
ELSEIF nTST=2
   lPAISAGEM := .T.
ENDIF
**************************************

/*
nGDBAR := 2
TRJANELA(18,25,20,55,,"Testa cdigo de barras?", .T.)
@ 19,30 PROMPT " Sim "
@ 19,45 PROMPT " No "
MENU TO nGDBAR
*/
nGDBAR := 1
nMODO  := 4

nXL := 2
TRJANELA(21,25,23,55,,"Testa planilha do Excel?", .T.)
@ 22,30 PROMPT " Sim "
@ 22,45 PROMPT " No "
MENU TO nXL
IF nXL = 1
  nMODO := 5
ELSE
  nMODO := 4
ENDIF
**************************************

RELATORIO(1, , , , nMODO)
* RELATORIO(1)
* RELATORIO(1,  , , , 4)
* RELATORIO(1, 4,"relat1.txt", ,nMODO)
* RELATORIO(1,3) // PERGUNTA DIRETO QUAL IMPRESSORA QUER IMPRIMIR
* RELATORIO(1, , , , 3) // DRAFT NA LPT1

LL = 0

IF nMODO=4 .OR. nMODO=3
		// TESTE NORMAL SEM CDIGO DE BARRAS
		
		// FILLRECT( <nX1>, <nY1>, <nX2>, <nY2>, <nRGBColor>)
		@ LL,00 SAY "[*FILLRECT(10,100,4940,200,8716288)]" // DESENHA CAIXA PREENCHIDA AZUL NA TELA DE PONTA A PONTA
		#IFDEF __XHARBOUR
			LL++
		#ENDIF
		cTXT = "TESTE DE CARACTERES POR POLEGADA - CPI"
		@ LL,(80-LEN(cTXT))/2 SAY "[10CPI][BI][COLOR:W]"+cTXT+"[\BI][COLOR:N]"  // LETRAS BRANCAS
		
		LL++
		@ LL++,00 SAY "[*CPI(2)]TESTE COM 2 CPI"
		@ LL++,00 SAY "[5CPI]TESTE COM 5 CPI"
		@ LL++,00 SAY "[6CPI]TESTE COM 6 CPI"
		@ LL++,00 SAY "[10CPI]TESTE COM 10 CPI"
		@ LL++,00 SAY "1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890"
		@ LL++,00 SAY "[12CPI]TESTE COM 12 CPI"
		@ LL++,00 SAY "1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890"
		@ LL++,00 SAY "[17CPI]TESTE COM 17 CPI"
		@ LL++,00 SAY "12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890"
		@ LL++,00 SAY "[20CPI]TESTE COM 20 CPI"
		@ LL++,00 SAY "12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890"
		@ LL++,00 SAY "[*CPI(25)]TESTE COM 25 CPI"
		@ LL++,00 SAY "12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890"
		@ LL++,00 SAY "[5CPI]5CPI [6CPI]6CPI [10CPI]10CPI [12CPI]12CPI [17CPI]17CPI [20CPI]20CPI [6CPI]6CPI [20CPI]20CPI [10CPI]10CPI [5CPI]5CPI [12CPI]12CPI [17CPI]17CPI"

		LL+=2
		//   @ LL++,00 SAY "[5CPI]GRFICOS:[*BMP('TCHARAM.BMP', {,,300,179})] [10CPI]"
		@ LL++,00 SAY "[5CPI]GRFICOS:[*BMP('TCHARAM.BMP', {,,30,18},,.T.)] [10CPI]"

		LL+=3
		cTXT = "TESTE DE ESTILOS DE FONTE"
		@ LL++,(80-LEN(cTXT))/2 SAY "[10CPI][BI]"+cTXT+"[\BI]"

		LL++
		@ LL++,00 SAY "TESTE [B]NEGRITO[\B] NESTA LINHA; E [B]AQUI[\B] ; E [B]AQUI[\B]; E [B]AQUI[\B]. SOBRESCRITO: X[SOB]5[\SOB]+Y[SOB]7[\SOB]=525X+323Y"
		@ LL++,00 SAY "TESTE [I]ITALICO[\I] NESTA LINHA; E [I]AQUI[\I] ; E [I]AQUI[\I]; E [I]AQUI[\I]. SUBSCRITO: H[SUB]2[\SUB]O"
		@ LL++,00 SAY "TESTE [U]SUBLINHADO[\U] NESTA LINHA; E [U]AQUI[\U] ; E [U]AQUI[\U]; E [U]AQUI[\U]"
		@ LL++,00 SAY "TESTE [B]NEGRITO[\B] [I]ITALICO[\I] [U]SUBLINHADO[\U] [BIU]NEGRITO+ITALICO+SUBLINHADO[\BIU] NESTA LINHA"

		LL++

		@ LL++,00 SAY "[10CPI]ALINHAMENTO:"
		@ LL++,00 SAY "[C]CENTRALIZADO"
		@ LL++,00 SAY "[R]ALINHADO  DIREITA"
		@ LL++,00 SAY "[L]ALINHADO  ESQUERDA"

		LL++
		cTXT = "TESTE DE ESPAAMENTO DE LINHA"
		@ LL++,(80-LEN(cTXT))/2 SAY "[BI]"+cTXT+"[\BI]"
		LL++
		@ LL++,00 SAY "[LS4]ESPACAMENTO 4"
		@ LL++,00 SAY "ESPACAMENTO 4"
		@ LL++,00 SAY "[LS5]ESPACAMENTO 5"
		@ LL++,00 SAY "ESPACAMENTO 5"
		@ LL++,00 SAY "[LS6]ESPACAMENTO 6 -NORMAL, PADRO"
		@ LL++,00 SAY "ESPACAMENTO 6"
		@ LL++,00 SAY "[LS7]ESPACAMENTO 7"
		@ LL++,00 SAY "ESPACAMENTO 7"
		@ LL++,00 SAY "[*LS(7.3)]ESPACAMENTO 7.3 -TAMANHO PERSONALIZADO"
		@ LL++,00 SAY "ESPACAMENTO 7.3"
		@ LL++,00 SAY "[LS8]ESPACAMENTO 8"
		@ LL++,00 SAY "ESPACAMENTO 8"
		@ LL++,00 SAY "[LS9]ESPACAMENTO 9"
		@ LL++,00 SAY "ESPACAMENTO 9"

		cTXT = "TESTE DE CARACTERES GRFICOS E ACENTUAO"
		@ LL++,(80-LEN(cTXT))/2 SAY "[LS6][BI]"+cTXT+"[\BI]"
		@ LL++,00 SAY "ĿĿĿ ͻ ͻ ͻ  "
		@ LL++,00 SAY "  Ĵ      ͹         "
		@ LL++,00 SAY " ͼ ͼ ͼ   ƈ "

		LL++
		cTXT = "TESTE COM FONTES (FONT FACE)"
		@ LL++,(80-LEN(cTXT))/2 SAY "[LS6][BI]"+cTXT+"[\BI]"

		@ LL++,0 SAY "[10CPI][*FON('MONOTYPE CORSIVA')]Monotype Corsiva [10CPI]10CPI [12CPI]12CPI [17CPI]17CPI [20CPI]20CPI"
		@ LL++,0 SAY "[10CPI][COURIER]COURIER NEW [10CPI]10CPI [12CPI]12CPI [17CPI]17CPI [20CPI]20CPI"
		@ LL++,0 SAY "[10CPI][TIMES]TIMES NEW ROMAN [10CPI]10CPI [12CPI]12CPI [17CPI]17CPI [20CPI]20CPI"
		@ LL++,0 SAY "[10CPI][LUCIDA]LUCIDA CONSOLE [10CPI]10CPI [12CPI]12CPI [17CPI]17CPI [20CPI]20CPI"
		@ LL++,0 SAY "[10CPI][VERDANA]VERDANA [10CPI]10CPI [12CPI]12CPI [17CPI]17CPI [20CPI]20CPI"
		@ LL++,0 SAY "[10CPI][ARIAL]ARIAL  [10CPI]10CPI [12CPI]12CPI [17CPI]17CPI [20CPI]20CPI"
		
		@ LL,0 SAY "[10CPI][COURIER]WINGDINGS [WINGDINGS]"
		FOR X=33 TO 102
			@ PROW(),PCOL() SAY CHR(X)
		NEXT
		LL++
		@ LL,0 SAY "[10CPI][COURIER]WINGDINGS [WINGDINGS]"	
		FOR X=103 TO 175
			@ PROW(),PCOL() SAY CHR(X)
		NEXT
		@ PROW(),PCOL() SAY CHR(225) // SETA PARA ESQUERDA
		LL++
		/*
		@ LL,0 SAY "[10CPI][COURIER]WINGDINGS [WINGDINGS]"	
		@ PROW(),PCOL() SAY CHR(230) // ESTRELA NO CIRCULO PINTADO
		@ PROW(),PCOL() SAY CHR(241) // MIRA REDONDA
		@ PROW(),PCOL() SAY CHR(246) // SETA DIAGONAL BAIXO ESQUERDA
		@ PROW(),PCOL() SAY CHR(248) // MIRA QUADRADA
		@ PROW(),PCOL() SAY CHR(250) // RELGIO
		@ PROW(),PCOL() SAY CHR(253) // ESTRELA 4 PONTAS
		@ PROW(),PCOL() SAY CHR(255) // PONTINHO
		LL++
		*/
		
		@ LL,0 SAY "[10CPI][COURIER]WEBDINGS [*FON('WEBDINGS',2)]" // 2=SYMBOL CHARSET
		FOR X=103 TO 175
			@ PROW(),PCOL() SAY CHR(X)
		NEXT
		
		LL+=2
		cTXT = "TESTE COM CORES"
		@ LL++,(80-LEN(cTXT))/2 SAY "[LS6][COURIER][BI][10CPI]"+cTXT+"[\BI]"
		@ LL++,0 SAY "  [COLOR:B] AZUL          [COLOR:G] VERDE     [COLOR:BG] CIANO   [COLOR:GR+] AMARELO"
		@ LL++,0 SAY "  [COLOR:R] VERMELHO      [COLOR:RB] MAGENTA   [COLOR:GR] MARROM  [COLOR:N] PRETO  "		

		@ LL++,0 SAY "[*CPI(25)][COURIER]SIBRA - Sistema de Impresso BRAsileiro: https://www.linguagemclipper.com.br/sibra"

		// CDIGO DE BARRAS
		LL := 0

		// BOX( <nX1>, <nY1>, <nX2>, <nY2>, [<nWidth>], [<nHeight>] )
		@ LL,00 SAY "[*BOX(10,100,4940,200)]" // DESENHA CAIXA NA TELA DE PONTA A PONTA
		#IFDEF __XHARBOUR
			LL++
		#ENDIF
		cTXT = "TESTE C/ CDIGO DE BARRAS"
		@ LL,(80-LEN(cTXT))/2 SAY "[LS6][BI][10CPI]"+cTXT+"[\BI]"
	
		LL+=2
		// O 6 PARAMETRO  O TEXTO DO CODIGO DE BARRAS, IMPRIME .T. OU NO IMPRIME .F.
		/*
		CB(cBARRAS, aRETANG, cTIPO, nZOOM, lCODIGO, nALTURA, cDESC, lmm, lDESC, nFLAGS)
		cBARRAS =  o nmero a ser representado pelo cdigo de barras. Tipo caracter.
		aRETANG = So as coordenadas X e Y de exibio do cdigo de barras.Tipo array. X  a posio horizontal/ Y  a vertical.
		cTIPO   = Tipo do cdigo de barras: EAN13, EAN8, UPCA, UPCE, CODE39, CODE39, CODE39,
		          CODE39, ITF, ITF, MSI, MSI, MSI, CODABAR, CODE93, CODE11, CODE128, PDF417,
				  DATAMATRIX.	
		nZOOM   = aumenta ou diminui o tamanho da imagem preservando suas propor;es ao tamanho original. Nmero maior, aumenta/ nmero menor, diminui. O Zoom padro para EAN13 e EAN8  3, enquanto que, 4 para EAN128 e FEBRABAN.
		lCODIGO = Imprime ou no, a numerao do cdigo de barras. O padro  .T. (imprime).
		nALTURA = Aumenta a altura do cdigo de barras. Este parmetro  multiplicado pela altura padro das barras. O padro  1. Por exemplo, caso queira que as barras sejam 50% mais altas, use 1.5/ caso queira que seja o dobro da altura, use 2.
		cDES    = Descrio do objeto referente ao cdigo de barras. Texto que aparecer no canto superior esquerdo do cdigo de barras. Este parmetro  opcional.
		lmm     = .T. ou .F. Define se os parmetros sero em milmetros (.T.) ou em pixels (.F.).
		lDESC   = .T. ou .F. Define o tamanho da descrio.
		nFLAGS  = ZEBRA FLAGs: 0 (PADRO) = NIL; 1=HB_ZEBRA_FLAG_CHECKSUM; 2=HB_ZEBRA_FLAG_CHECKSUM + HB_ZEBRA_FLAG_WIDE2_5; 3=HB_ZEBRA_FLAG_CHECKSUM + HB_ZEBRA_FLAG_WIDE3; 4=HB_ZEBRA_FLAG_WIDE3; 5=HB_ZEBRA_FLAG_WIDE2_5
							   Para CODABAR e CODE11 a flag padro  4 (HB_ZEBRA_FLAG_WIDE3)
		*/

		// Saiba mais:
		// https://www.bztech.com.br/blog/o-que-e-um-codigo-de-barras-e-sua-importancia

		LL++
		*** EXEMPLOS COM ASPAS SIMPLES EM REDOR DA VARIAVEL PARA TORNA-LAS STRING
		*** IMPRIME 4 EAN13 LADO A LADO
		cBARRAS := "789136043123" // EXEMPLO SEM DESCRIO, SEM LINHA DIGITVEL E 50% MAIS ALTO
		@ LL,00 SAY "EAN13: [*CB('"+cBARRAS+"',, 'EAN13',,.T.,1.5)]" // .F. ->SEM LINHA DIGITAVEL

		cBARRAS := "789136043456" // EXEMPLO SEM DESCRIO, MAS COM LINHA DIGITVEL
		@ LL,66 SAY "[*CB('"+cBARRAS+"',, 'EAN13',,.T.,2)]"

		cBARRAS := "789136043777" // EXEMPLO COM DESCRIO E LINHA DIGITVEL
		cDESC := "CAMISA BRANCA"
		@ LL,120 SAY "[*CB('"+cBARRAS+"',, 'EAN13',,.T.,,'"+cDESC+"')]"

		cBARRAS := "789136043345"
		cDESC := "CAMISA PLO"
		@ LL++,186 SAY "[*CB('"+cBARRAS+"',, 'EAN13',,.F.,,'"+cDESC+"')]"

		LL+=2
		cBARRAS := "0421000" // EXEMPLO COM CHR(34)+cVARIAVEL+CHR(34)
		@ LL,00 SAY "EAN8: [*CB("+CHR(34)+cBARRAS+CHR(34)+",, 'EAN8')]"
		
		cDESC := "CAMISA PLO"
		@ LL++,50 SAY "[*CB('"+cBARRAS+"',, 'EAN8',,,,'"+cDESC+"')]"

		LL+=2
		cBARRAS := "01234567891"  
		@ LL++,00 SAY "UPCA: [*CB('"+cBARRAS+"',, 'UPCA')]"
		
		LL+=2
		cBARRAS := "123456"  
		@ LL++,00 SAY "UPCE: [*CB('"+cBARRAS+"',, 'UPCE')]"
		
		LL+=2
		cBARRAS := "ABC123"  
		@ LL  ,000 SAY "CODE39: [*CB('"+cBARRAS+"',, 'CODE39')]"
		@ LL  ,050 SAY "[*CB('" + cBARRAS + "',, 'CODE39',,,,,,,1)]"
		@ LL  ,105 SAY "[*CB('" + cBARRAS + "',, 'CODE39',,,,,,,2)]"
		LL+=2
		@ LL++,008 SAY "[*CB('" + cBARRAS + "',, 'CODE39',,,,,,,3)]"

		LL+=2
		// ITF PADRO DE BOLETOS BANCRIOS
		cBARRAS := "1234"  
		@ LL  ,000 SAY "ITF: [*CB('"+cBARRAS+"',, 'ITF',,,,,,,4)]"	 // 4=HB_ZEBRA_FLAG_WIDE3	
		cBARRAS := "12345678901" 
		@ LL  ,060 SAY "[*CB('"+cBARRAS+"',, 'ITF',,,,,,,1)]"		 // 1=HB_ZEBRA_FLAG_CHECKSUM
		LL+=2
		cBARRAS := "074891122220015790723923348021058990570000029704" 
		@ LL  ,000 SAY "[*CB('" + cBARRAS + "',, 'ITF',,.F.,,,,,1)]" // 1=HB_ZEBRA_FLAG_CHECKSUM
		

		LL+=3
		cBARRAS := "1234"  
		@ LL  ,000 SAY "MSI: [*CB('"+cBARRAS+"',,'MSI')]"
		@ LL  ,050 SAY "[*CB('" + cBARRAS + "',, 'MSI',,,,,,,3)]"
		cBARRAS := "1234567" 
		@ LL  ,105 SAY "[*CB('" + cBARRAS + "',, 'MSI',,,,,,,1)]"

		LL+=3
		cBARRAS := "40156"  
		@ LL  ,00 SAY "CODABAR: [*CB('"+cBARRAS+"',,'CODABAR')]"
		cBARRAS := "-1234"  
		@ LL  ,60 SAY "[*CB('" + cBARRAS + "',, 'CODABAR')]"
		
		LL+=3
		cBARRAS := "ABC-123"  
		@ LL  ,000 SAY "CODE93: [*CB('"+cBARRAS+"',,'CODE93')]"
		cBARRAS := "TEST93"  
		@ LL  ,050 SAY "[*CB('" + cBARRAS + "',, 'CODE93')]"
		
		LL+=3
		cBARRAS := "12"  
		@ LL  ,000 SAY "CODE11: [*CB('"+cBARRAS+"',,'CODE11')]"
		cBARRAS := "1234567890"  
		@ LL  ,050 SAY "[*CB('" + cBARRAS + "',, 'CODE11',,,,,,,3)]"	
		
		LL+=3
		cBARRAS := "Code 128"  // PADRO DE NOTAS FISCAIS
		@ LL  ,000 SAY "CODE128: [*CB('"+cBARRAS+"',,'CODE128')]"
		cBARRAS := "1234567890"  
		@ LL  ,060 SAY "[*CB('" + cBARRAS + "',, 'CODE128')]"
		cBARRAS := "Wikipedia"  
		@ LL  ,110 SAY "[*CB('" + cBARRAS + "',, 'CODE128')]"
		
		LL+=3
		cBARRAS := "Hello, World of Harbour!!! It is 2D barcode PDF417 :)"  
		@ LL  ,000 SAY "PDF417: [*CB('"+cBARRAS+"',,'PDF417')]"
		
		LL+=6
		cBARRAS := "Hello, World of Harbour!!! It is 2D barcode DataMatrix :)"  
		@ LL  ,000 SAY "DATAMATRIX: [*CB('"+cBARRAS+"',,'DATAMATRIX',2)]"		
		
		LL+=6
		// cBARRAS := "https://linguagemclipper.com.br/impressoras/sibra-impressora-usb-clipper-excel"		
		cBARRAS := "https://www.reverde.com.br/desconto-na-luz?re=r54zm"  
		@ LL  ,000 SAY "QRCODE: [*CB('"+cBARRAS+"',,'QRCODE',5)]"		
		
	  *-------------------------------------------------------------------------------------------------
	  // EXEMPLO DE IMPRESSO DE BOLETO DA CAIXA ECONMICA FEDERAL
	  *-------------------------------------------------------------------------------------------------
      EJECT
	  ***********************
	  *** DADOS DO BOLETO ***
	  ***********************
      titular:="Fernando Dias"
      ender:="Rua Coronel Gracia, 541"
      fone:="(42) 3422-2994 / 3422-4664"
      vvcompa:="04/08/2009" // VENCIMENTO
      vvagcc:="0390/2013568"
      vdatadia:=dtoc(date())
      vvprot:="200801234"      
      vnosnumt:="24000000200801234"
      vvaltot:="44,96"
      vvdeve:=LEFT( "K L S DISTRIUBUIDORA  DE ALIMENTOS LTDA.                       ",55)
      vvende:=LEFT("RUA JABAQUARA DOS SANTOS LIMA DUARTE SARAIVA, 122 CEP 77.123-000",55)
      vvtitiden:="CNPJ"
      vviden:="12.123.456/0001-99"
	  
	  // ATENO: SEU SISTEMA DEVE SER CAPAZ DE GERAR AS INFORMAES ABAIXO DOS CAMPOS
	  // DA LINHA DIGITVEL E DO CDIGO DE BARRAS!
	  // O CDIGO ABAIXO NO EST UTILIZVEL EM MODO PRODUO,  UM EXEMPLO PARCIAL.
	  ********************************************************************************
	  * COMPOSIO DA LINHA DIGITVEL DA CAIXA	  
	  cBANCO   := "104"     // CEF:  3 DGITOS
	  cMOEDA   := "9"       // REAL, CDIGO DA MOEDA 
	  cLIVRE1  := "14319"   // CAMPO LIVRE: 5 DGITOS
	  cDIGVER1 := "0"       // DGITO VERIFICADOR
	  cLINHA1  := cBANCO+cMOEDA+cLIVRE1+cDIGVER1
	  cLINHA1  := TRANSFORM(cLINHA1, "@R 99999.99999")
	  
	  cLIVRE2  := "0000044972"
	  cDIGVER2 := "0"
	  cLINHA2   := cLIVRE2+cDIGVER2
	  cLINHA2  := TRANSFORM(cLINHA2, "@R 99999.999999")
	  
	  cLIVRE3  := "135680002"
	  cDIGVER3 := "0"
	  cLINHA3  := cLIVRE2+cDIGVER2
	  cLINHA3  := TRANSFORM(cLINHA3, "@R 99999.999999")
	  
	  cDVGERAL := "0"
	  cLINHA4  := cDVGERAL // DGITO VERIFICADOR GERAL
	  
	  // FATOR VENCIMENTO COM 4 DGITOS
	  nVENC   := CTOD(vvcompa)-CTOD("07/10/1997") // VENCIMENTO - DATA BASE
	  cVENC   := STR(nVENC,4)                     // FATOR DE VENCIMENTO COM 4 DGITOS
	  
	  // VALOR DO BOLETO
	  cVAL1  := STRTRAN(vvaltot, ",") // RETIRA VRGULA
	  cVAL1  := STRTRAN(cVAL1, ".") // RETIRA PONTOS
	  cVALOR  := REPLICATE("0", 10-LEN(cVAL1))+cVAL1 // VALOR COM 10 DGITOS
	  cLINHA5 := cVENC+cVALOR	  
	  
	  // LINHA DIGITVEL
	  cLINHA  := cLINHA1+" "+cLINHA2+" "+cLINHA3+" "+cLINHA4+" "+cLINHA5
	  
	  * COMPOSIO DO CDIGO DE BARRAS: 44 POSIES
	  * CAMPO LIVRE:
	  cBENEF    := "1234567" // CDIGO DO CONVNIO/BENEFICIRIO
	  cNNUMSEQ1 := "123"     // NOSSO NMERO - SEQUNCIA 1
	  cCONST1   := "1"       // CONSTANTE 1
	  cNNUMSEQ2 := "456"
	  cCONST2   := "2"
	  cNNUMSEQ3 := "123456789"
	  cDVBARRAS := "1"       // DV DO CAMPO LIVRE
	  cCALIVRE  := cBENEF+cNNUMSEQ1+cCONST1+;
						  cNNUMSEQ2+cCONST2+;
						  cNNUMSEQ3+cDVBARRAS	
	  
	  // CDIGO DE BARRAS
	  cBARRAS := cBANCO+cMOEDA+cDVGERAL+cVENC+cVALOR+;
				 cCALIVRE
	  *----------------------------------------------------------------------------------	  
	  vcodb:= cBARRAS
	  *----------------------------------------------------------------------------------
	  
	  // H DIFERENA DE ESPAAMENTO DE LINHAS ENTRE O XHARBOUR E O HARBOUR
	  // OBSERVE OS COMANDOS LINE SPACING: [LS4] a [LS9]. ESPECIAL QUALQUER LS: [*LS(nLS)]
		#IFNDEF __XHARBOUR

			// HARBOUR
			@prow()+1,10 say "[COURIER] [10CPI] HARBOUR"
			@prow()+1,10 say "Boleto valor R$ 44,97, vencimento "+vvcompa	  
			@prow()+1,10 say "Obs.: A imagem do boleto est ultrapassada, mas serve de exemplo."
			******************************************************************
			// BOLETO DADOS POSICIONADOS CORRETAMENTE NO BOLETO USANDO HARBOUR
			******************************************************************
			// 1a VIA SACADO
			@prow()+9,05 SAY "[LS8] [*BMP('BOLCAI.BMP', {,,310,170},14)]" // IMAGEM DO BOLETO DA CEF
			@prow()+1,62 say "[VERDANA] [B] [17CPI] RECIBO DO SACADO [10CPI] [\B] [LS7]"
			@prow()+2,12 say "[COURIER] [17CPI] PAGVEL PREFERENCIALMENTE NAS CASAS LOTRICAS, AGNCIAS DA CAIXA E TODA A REDE BANCRIA    [12CPI] &vvcompa[17CPI][*LS(7.5)]"
			@prow()+2,12 say "[COURIER] [12CPI]  IRATI PROTESTO DE TTULOS"+SPACE(40)+"&vvagcc[*LS(7.3)]"
			@prow()+2,12 say vdatadia+space(6)+vvprot+space(24)+vdatadia+space(7)+vnosnumt
			@prow()+2,26 say "SR"+space(7)+"R$"+space(37)+vvaltot+"[LS7]"
			@ prow()+10,16 say vvdeve+space(3)+vvtitiden
			@prow()+1,16 say vvende+space(3)+vviden+"[20CPI][*LS(10)]"
			*******************************************************************************************
			@prow()+3,17 say "[*CB('&vcodb',,'ITF',0.5,.F.,4,,,,5)]"  // IMPRIME O CDIGO DE BARRAS ITF  
			*******************************************************************************************

			*****************
			@prow()+8,08 SAY "[20CPI]...[10CPI][WINGDINGS]"+CHR(35)+"[COURIER][20CPI]"+REPLICATE(".",140)+"[10CPI]"
			*****************
			
			// 2a VIA COMPENSACAO
			@prow()+5,05 SAY "[LS8] [*BMP('BOLCAI.BMP', {,,310,170},14)]" // IMAGEM DO BOLETO DA CEF
			@prow()+1,25 say "[VERDANA] [B] [12CPI]  "+ cLINHA // LINHA DIGITVEL
			@prow()+2,16 say "[COURIER] [17CPI] PAGVEL PREFERENCIALMENTE NAS CASAS LOTRICAS, AGNCIAS DA CAIXA E TODA A REDE BANCRIA    [12CPI] &vvcompa[17CPI][*LS(7)]"
			@prow()+2,12 say "[COURIER] [12CPI]  IRATI PROTESTO DE TTULOS"+SPACE(40)+"&vvagcc[*LS(7.3)]"
			@prow()+2,12 say vdatadia+space(6)+vvprot+space(24)+vdatadia+space(7)+vnosnumt
			@prow()+2,26 say "SR"+space(7)+"R$"+space(37)+vvaltot+"[LS7]"
			@prow()+10,16 say vvdeve+space(3)+vvtitiden
			@prow()+1,16 say vvende+space(3)+vviden
			@prow()+1,80 say "[20CPI]Ficha de Compensao[*LS(15)]"
			****************************************************************************************
			@prow()+3,17 say "[*CB('&vcodb',,'ITF',0.5,.F.,4,,,,5)]"  // IMPRIME O CDIGO DE BARRAS  
			****************************************************************************************	
		
		#ELSE
			
			// XHARBOUR		  
			@prow()+1,10 say "[COURIER] [10CPI] [LS6] XHARBOUR E CLIPPER"
			@prow()+1,10 say "Boleto valor R$ 44,97, vencimento "+vvcompa	 
			@prow()+1,10 say "Obs.: A imagem do boleto est ultrapassada, mas serve de exemplo."		
			*****************************************************************************
			// BOLETO DADOS POSICIONADOS CORRETAMENTE NO BOLETO USANDO XHARBOUR E CLIPPER
			*****************************************************************************
			// 1a VIA SACADO
			@prow()+15,05 SAY "[LS9] [*BMP('BOLCAI.BMP', {,,310,170},14)]" // IMAGEM DO BOLETO DA CEF
			@prow()+3,62 say "[VERDANA] [B] [17CPI] RECIBO DO SACADO [10CPI] [\B] [LS8]"
			@prow()+2,12 say "[COURIER] [17CPI] PAGVEL PREFERENCIALMENTE NAS CASAS LOTRICAS, AGNCIAS DA CAIXA E TODA A REDE BANCRIA    [12CPI] &vvcompa[17CPI][*LS(7.5)]"
			@prow()+2,12 say "[COURIER] [12CPI]  IRATI PROTESTO DE TTULOS"+SPACE(40)+"&vvagcc[*LS(7.3)]"
			@prow()+2,12 say vdatadia+space(6)+vvprot+space(24)+vdatadia+space(7)+vnosnumt
			@prow()+2,26 say "SR"+space(7)+"R$"+space(37)+vvaltot+"[LS7]"
			@ prow()+10,16 say vvdeve+space(3)+vvtitiden
			@prow()+1,16 say vvende+space(3)+vviden+"[20CPI][*LS(15)]"
			****************************************************************************************
			@prow()+2,17 say "[*CB('&vcodb',,'ITF',,.F.,1.8,,,,1)]"  // IMPRIME O CDIGO DE BARRAS
			****************************************************************************************

			*****************
			@prow()+10,08 SAY "[20CPI]...[10CPI][WINGDINGS]"+CHR(35)+"[COURIER][20CPI]"+REPLICATE(".",140)+"[10CPI]"
			*****************
			
			// 2a VIA COMPENSACAO
			@prow()+2,05 SAY "[*LS(10)] [*BMP('BOLCAI.BMP', {,,310,170},14)]"
			@prow()+3,25 say "[VERDANA] [B] [12CPI]  "+TRANSFORM(vcodb, "@R 99999.9999999999.999999 99999.999999 9 99999999999999")+" [10CPI] [\B] [LS7]" // NUMERAO DO BOLETO
			@prow()+2,12 say "[COURIER] [17CPI] PAGVEL PREFERENCIALMENTE NAS CASAS LOTRICAS, AGNCIAS DA CAIXA E TODA A REDE BANCRIA    [12CPI] &vvcompa[17CPI][*LS(7.5)]"
			@prow()+2,12 say "[COURIER] [12CPI]  IRATI PROTESTO DE TTULOS"+SPACE(40)+"&vvagcc[*LS(7.3)]"
			@prow()+2,12 say vdatadia+space(6)+vvprot+space(24)+vdatadia+space(7)+vnosnumt
			@prow()+2,26 say "SR"+space(7)+"R$"+space(37)+vvaltot+"[LS7]"
			@prow()+10,16 say vvdeve+space(3)+vvtitiden
			@prow()+1,16 say vvende+space(3)+vviden
			@prow()+1,80 say "[*CPI(25)][*LS(90)]Ficha de Compensao"
			****************************************************************************************
			@prow()+1,21 say "[*CB('&vcodb',,'ITF',,.F.,1.8,,,,1)]"  // IMPRIME O CDIGO DE BARRAS
			****************************************************************************************	  
		#ENDIF

	
ELSEIF nMODO=5
       *********************************************************************
       *** VEJA COMO EH FACIL CRIAR UMA PLANILHA DO EXCEL C/ O SIBRA XL! ***
       *********************************************************************
       // FONTE PADRAO DA PLANILHA (DEFAULT)
       @ LL++,00 SAY "[FONT:VERDANA]"

       // VOU CRIAR UM CABECALHO NESTAS LINHAS
       // ELE VAI SER IMPRESSO EM CADA FOLHA AUTOMATICAMENTE
       // SO ESTARA VISIVEL QUANDO IMPRIMIR OU VISUALIZAR A IMPRESSAO
       @ LL++,00 SAY "[LINHAS:3][PAG][BORDAS:A3C]"

       * TITULO DO RELATORIO
       @ LL++,00 SAY "[CEL(1,1):TEXTO:RELATORIO DE IMPRESSORAS DISPONIVEIS EM MODO TEXTO DO SIBRA]"
       @ LL++,00 SAY "[CEL(1,1):TAM:12]"
       @ LL++,00 SAY "[CEL(1,1):NEGRITO]"
       @ LL++,00 SAY "[CEL(1,1):FONT:TIMES NEW ROMAN]"

       * TAMANHO DAS COLUNAS
       * Se o tamanho da coluna nao tiver bom, ajeite manualmente no Excel
       * e veja nele mesmo qual eh o numero que fica bom p/ acertar o programa.
       @ LL++,00 SAY "[TCOL(1):16,57]"
       @ LL++,00 SAY "[TCOL(2,3):18,29]"

       * TITULO DAS COLUNAS
       @ LL++,00 SAY "[CEL(3,1):TEXTO:FABRICANTE]" // EMPRESA
       @ LL++,00 SAY "[CEL(3,1):NEGRITO]"
       @ LL++,00 SAY "[CEL(3,1):AH:C]"
       @ LL++,00 SAY "[CEL(3,1):COR:BRANCO]"
       @ LL++,00 SAY "[CEL(3,1):INTERIOR:AZUL ESCURO]"

       @ LL++,00 SAY "[CEL(3,2):TEXTO:IMPRESSORA]" // IMPRESS
       @ LL++,00 SAY "[CEL(3,2):NEGRITO]"
       @ LL++,00 SAY "[CEL(3,2):AH:C]"
       @ LL++,00 SAY "[CEL(3,2):COR:BRANCO]"
       @ LL++,00 SAY "[CEL(3,2):INTERIOR:AZUL ESCURO]"

       @ LL++,00 SAY "[CEL(3,3):TEXTO:EMULA]"      // EMULA
       @ LL++,00 SAY "[CEL(3,3):NEGRITO]"
       @ LL++,00 SAY "[CEL(3,3):AH:C]"
       @ LL++,00 SAY "[CEL(3,3):COR:BRANCO]"
       @ LL++,00 SAY "[CEL(3,3):INTERIOR:AZUL ESCURO]"

       * INICIO DO RELATORIO *
       USE PRINTER ALIAS PRN SHARED NEW
       nCEL := 4
       DO WHILE !PRN->(EOF())
			cCEL := ALLTRIM(STR(nCEL))
			// [CEL(6,1):TEXTO:TEXTO DA CELULA]
			@ LL++,00 SAY "[CEL(" + cCEL + ",1):TEXTO:" + PRN->EMPRESA +"]" // COLUNA 1 (A)
			@ LL++,00 SAY "[CEL(" + cCEL + ",2):TEXTO:" + PRN->IMPRESS +"]" // COLUNA 2 (B)
			@ LL++,00 SAY "[CEL(" + cCEL + ",3):TEXTO:" + PRN->EMULA +"]"   // COLUNA 3 (C)
			nCEL++
			PRN->(DBSKIP())
       ENDDO
ENDIF

* RELATORIO(0, lPAISAGEM,,,,,,"PAG:109") // ENVELOPE #1 165x102mm
 RELATORIO(0, lPAISAGEM)
* RELATORIO(0, lPAISAGEM, , , "1,,1,") // COM MARGENS: 1 CABECALHO E 1 MARGEM ESQUERDA
* RELATORIO(0, lPAISAGEM, "80/86/800/810")
* RELATORIO(0, lPAISAGEM, "Epson LX-810")
* RELATORIO(0, lPAISAGEM, "EPSON Stylus COLOR 740")
**************************************

INKEY(1)




**********************************************
* LISTA EXEMPLIFICATIVA DE COMANDOS P/ EXCEL *
**********************************************
* [FONT:ARIAL NARROW]
* [LINHAS:5] [PAG] [LOGO(C):CBTU.BMP] [BORDAS:A5I]
* [HCOL(C):2,3,8,9] [HCOL(E):1,4,5,6,7]
* [TCOL(6,7):27]

* [CEL(L,C):RETORNO]
* [CEL(L,C):NEGRITO]
* [CEL(L,C):ITALICO]
* [CEL(L,C):SUBLINHADO]
* [CEL(L,C):SOBRESCRITO]
* [CEL(L,C):SUBSCRITO]
* [CEL(L,C):SOMBRA]
* [CEL(L,C):CONTORNO]
* [CEL(L,C):TACHADO]
* [CEL(L,C):TAM:9]
* [CEL(L,C):FONT:ARIAL]
* [CEL(L,C):AV:C]
* [CEL(L,C):AH:C]
* [CEL(L,C):TEXTO:ISSO AQUI EH TEXTO DA LINHA]
* [CEL(L,C):DATA:31/03/2011]
* [CEL(L,C):NUMERO:1000,00]
* [CEL(L,C):COR:BRANCO]
* [CEL(L,C):INTERIOR:AZUL ESCURO]
* [CEL(L,C):BORDA]
* [CEL(L,C):FORMULA:SUM(C1:C5)]
* [CEL(L,C):FORMATO:0.00%]

